// amAntiAirmailInv.uc
// Airmail "powerup" that can't be dropped for a set period of time
// Since this extends AirMailInv they can't pick up any other airmail powerups while they have this.
// It gets very annoying.

class amAntiAirmailInv extends AirMailInv;

var localized string CantDropThis;
var localized string OKToDrop;

var config float ForceHoldTime;

// tell 'em you can drop it now
function OKToDropNow()
{
	OurOwnerController.ClientMessage(OKToDrop);
	GotoState('');
}

// when grabbed, enter 'FooledYou' state which prohibits dropping of this powerup
function PickupFunction(Pawn Other)
{
	Super.Pickupfunction(Other);
	GotoState('FooledYou');
}

state FooledYou
{
	// Prevent throwing the powerup
	// May need to fix for players killed while holding this?
	function DropFrom(vector StartLocation)
	{
		OurOwnerController.ClientMessage(CantDropThis);
	}
Begin: // Sleep for the forceholdtime and then destroy.
	Sleep(ForceHoldTime);
	OKToDropNow();
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amAntiAirmailPickup'
	Description="ANTI-AIRMAIL: You fell for a trap! You can't drop this until 15 seconds have passed."
	CantDropThis="This is stuck in your inventory! Try dropping it later."
	OKToDrop="You can drop the anti-airmail package now."
	ForceHoldTime=15
}
