// amAntiRegenInv.uc
// Anti-Regeneration "powerup"
// while holding, our owner receives damage from the MpPawn designated by Prankster.

class amAntiRegenInv extends AirMailInv
	config(AirMail);

var MpPawn Prankster; // this value is assigned by the pickup
var vector HitMomentum; // will always be 0
var config int DamagePerSleep;

function Timer()
{
	// Take damage and spawn a little lightning
	OurOwner.TakeDamage(DamagePerSleep, Prankster, OurOwner.Location, HitMomentum, class'amAntiRegenDamage');
	spawn(class'ShockerPawnLightningMP',OurOwner,,OurOwner.Location,OurOwner.Rotation);

	Super.Timer();
}

// All this crap is copied from OwnedInv/P2PowerupInv.
// Gotta do this here so our Prankster value gets copied to the newly-spawned pickup.
///////////////////////////////////////////////////////////////////////////////
// Toss this item out.
///////////////////////////////////////////////////////////////////////////////
function DropFrom(vector StartLocation)
{
	local Pickup P;

	P = spawn(PickupClass,Instigator,,StartLocation);
	// if it's not spawned, try spawning it at the instigator
	if(P == None)
	{
		P = spawn(PickupClass,Instigator,,Instigator.Location);
	}

	if(P != None)
	{
		P.Instigator = Instigator;

		amAntiRegenPickup(P).Prankster = Prankster; // This is our only change, everything else is from the super

		if(UseForErrands == 1
			&& Instigator != None
			&& P2Pawn(Instigator).Health > 0
			&& P2Player(Instigator.Controller) != None)
		{
			// Player says something about important item being dropped
			P2Player(Instigator.Controller).NeedThatForAnErrand();
		}

		// If throw each one and you have more than one, then only spawn a copy
		if(bThrowIndividually && Amount > 1)
		{
			// Throw out one
			if ( P == None )
			{
				return;
			}
			P.InitDroppedPickupFor(self);
			P.Velocity = Velocity;
			Velocity = vect(0,0,0);
		}
		else
		{
			///////////////////////////////////////////////////////////////////////////////
			// Similar to DropFrom in Inventory.uc, but we pass the instigator along to
			// the spawned pickup as its owner, because we want to know who most recently
			// dropped this for errands
			///////////////////////////////////////////////////////////////////////////////
			if ( Instigator != None )
			{
				DetachFromPawn(Instigator);	
				Instigator.DeleteInventory(self);
			}	
			SetDefaultDisplayProperties();
			Inventory = None;
			Instigator = None;
			StopAnimating();
			// moved spawn line from here to top of function
			if ( P == None )
			{
				return;
			}
			P.InitDroppedPickupFor(self);
			P.Velocity = Velocity;
			Velocity = vect(0,0,0);
			// End of inventory.uc code
			ReduceAmount(Amount);
		}
	}
	// If it still failed, ask the inventory what he wants to do
	else
	{
		DropFailed();
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amAntiRegenPickup'
	Icon=Texture'AMTextures.Icons.GreenHealth'
	Sleep_Time = 0.5
	DamagePerSleep = 5
	Description="ANTI-REGEN: You've been tricked! Drop this item now!"
	AutoUseDesc="Can't activate this! Drop it now!"
	HitMomentum = 0
}
