// amAntiRegenPickup.uc
// Anti-Regeneration Pickup
// We have to override a bunch of shit here so that our Prankster value gets copied to the newly-created inventory.

class amAntiRegenPickup extends AirMailPickup;

var MpPawn Prankster;

state Pickup
{
	// You'll note that I forgot to copy the shit from AirMailPickup.
	// This was unintentional at first but then turned out to be a nice feature, because it lets you pick this up
	// even if you have another airmail package. This is good for our Prankster (and bad for our new owner!)
	function Touch( actor Other )
	{
		local Inventory Copy;
		local Trigger trig;
		local P2GameInfoSingle checkg;

		trig = Trigger(Other);

		if(trig != None)
		{
			// If you hit a trigger for looking for your class, and you have to do
			// with errands, check to complete an errand and destroy yourself
			if(trig.ClassIsChildOf(class, trig.ClassProximityType)
				&& bUseForErrands)
			{
				// See if this item is in an uncompleted errand
				checkg = P2GameInfoSingle(Level.Game);
				if(checkg != None)
					checkg.CheckForErrandCompletion(self, Other, Instigator, P2Player(Instigator.Controller), false);
				// Destroy it anyway, when it hits this
				Destroy();
				return;
			}
		}
		
		if(ValidTouch(Other))
		{
			Copy = SpawnCopy(Pawn(Other));
			AnnouncePickup(Pawn(Other));
			amAntiRegenInv(Copy).Prankster = Prankster; // This is the only change, everything else is from super
			Copy.PickupFunction(Pawn(Other));
			// Destroy possibly here instead of inside SpawnCopy
			SetRespawn();
		}
		// don't allow inventory to pile up (frame rate hit)
		else 
		{
			CheapBounce(Other);
		}
	}
}

defaultproperties
{
	InventoryType=class'amAntiRegenInv'
	PickupMessage="You picked up Anti-Regeneration."
}
