// amArcadeMachine.uc
// Destroyable Arcade Machine.
// Blocks people from getting by until it's destroyed.

class amArcadeMachine extends PropBreakable
	config(AirMail);

var localized string DestroyedMessage;
var config int OurHealth;

// OurHealth is a config so we can change it in airmail.ini if we want to.
function PostBeginPlay()
{
	Super.PostBeginPlay();
	Health = OurHealth;
}

// Place the machine on the ground
function FindGround()
{
	local Actor HitActor;
	local vector HitLocation, HitNormal, checkpos;
	local Rotator userot;

	checkpos = Location;
	checkpos.z -= 1500;

	HitActor = Trace(HitLocation, HitNormal, checkpos, Location, false);
	if(HitActor != None)
	{
		SetLocation(HitLocation);
	}
}

// When we break, inform our owner.
// The super handles everything else.
state Broken
{
	simulated function BeginState()
	{
		local PlayerController pc;
		local MpPawn OurOwner;

		OurOwner = MpPawn(Owner);
		If (OurOwner != None)
		{
			pc = PlayerController(OurOwner.Controller);
			if (pc != None)
				pc.ClientMessage(DestroyedMessage);
		}
		Super.BeginState();
	}
}

defaultproperties
{
	BreakEffectClass = class'GrenadeExplosion' // a nice grenade explosion when we die
	OurHealth = 50
	Health = 50
	StaticMesh=StaticMesh'ben_mesh.map_arcade.arcadeMachine_2TEX_ben' // defaults to Teen Sniper cabinet
	DrawType = DT_StaticMesh
	DestroyedMessage="Your arcade machine was destroyed"
}
