// amArcadeMachineInv.uc
// Arcade Machines

class amArcadeMachineInv extends AirMailInv;

// Spawns Arcade Machines to block other players.

var amArcadeMachine OurMachine;

var array<StaticMesh> Machines;
var localized string OurThrownMessage;
var localized string ErrorMessage;

// Get rid of our arcade machine if we drop this.
function RevokePowers(MpPawn Other)
{
	If (OurMachine != None)
		OurMachine.Destroy();
}

// This could have been written better using OurOwner and OurOwnerController
///////////////////////////////////////////////////////////////////////////////
// Active state: this inventory item is armed and ready to rock!
///////////////////////////////////////////////////////////////////////////////
function Activate()
{
	local MpPawn CheckPawn;
	local int MeshToUse;
	local P2Player p2p;
	local rotator userot;
	local vector MachineSpawnPoint;

	CheckPawn = MpPawn(Owner);
	if (CheckPawn != None)
	{
		p2p = P2Player(CheckPawn.Controller);
		if (OurMachine == None)
		{
			userot = CheckPawn.Rotation;
			MachineSpawnPoint = Owner.Location + vector(userot) * 100;
			OurMachine = spawn(class'amArcadeMachine', Owner,, MachineSpawnPoint, userot);
			if (fRand()<0.25) // 25% chance of spawning something silly
				OurMachine.SetStaticMesh(Machines[Rand(Machines.Length)]);
			OurMachine.FindGround();
			p2p.ClientMessage(OurThrownMessage);
		}
		else
			p2p.ClientMessage(ErrorMessage);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amArcadeMachinePickup'
	Icon=Texture'AMTextures.Icons.arcade'
	bThrowIndividually=False
	bDisplayAmount=True
	// 22 easter eggs.
	Machines[0]=StaticMesh'Timb_mesh.fooo.toilet' // A toilet
	Machines[1]=StaticMesh'dj-protostuff.Game_MagicSword' // 3 different arcade machines
	Machines[2]=StaticMesh'dj-protostuff.Game_NinjaGaiden'
	Machines[3]=StaticMesh'dj-protostuff.Game_TimeSoldiers'
	Machines[4]=StaticMesh'ben_mesh.misc.bigChineseTakeoutBox_ben' // The giant chinese takeout box from the mall
	Machines[5]=StaticMesh'ben_mesh.misc.pooltable_ben' // A pool table
	Machines[6]=StaticMesh'ben_mesh.misc.statue_lion_ben' // Statue of a lion
	Machines[7]=StaticMesh'ben_mesh.misc.vase03' // Dinky little vase (booby prize)
	Machines[8]=StaticMesh'dj-protostuff.vending_auto' // Food vending machine
	Machines[9]=StaticMesh'dj-protostuff.vending_coffee' // Coffee vendor
	Machines[10]=Staticmesh'dj-protostuff.vending_snack' // Snack vendor
	Machines[11]=Staticmesh'furniture-stv.retail_interior.gumball-machine-sw' // Little gumball machine (another booby)
	Machines[12]=Staticmesh'p2-details.coww' // because cows fucking rock
	Machines[13]=Staticmesh'p2-outdoors-sw.retail-outside.newspapermachine-sw' // newspaper vending machine
	Machines[14]=Staticmesh'p2-outdoors-sw.retail-outside.phonebooth-sw' // a phone booth
	Machines[15]=Staticmesh'timb_mesh.cactus.barrel_cactus_dawn' // a cactus
	Machines[16]=Staticmesh'timb_mesh.home.bed_timb' // a cozy-looking bed
	Machines[17]=Staticmesh'timb_mesh.cars.car_schoolbus' // a bigass schoolbus
	Machines[18]=Staticmesh'timb_mesh.fooo.smooshie_timb' // the slurpee machine
	Machines[19]=Staticmesh'timb_mesh.vote.votingbooth_dawn' // that damn voting booth
	Machines[20]=Staticmesh'timb_mesh.asylum.wheelchair_timb' // the wheelchair
	Machines[21]=Staticmesh'zo_greenbelt_meshes.junk.zo_carhusk' // a junked-out car
	Description="ARCADE MACHINE: Drop an arcade machine to protect against incoming fire."
	OurThrownMessage="Machine spawned"
	ErrorMessage="You already spawned a machine, destroy it to spawn another"
}
