// amAutoAmmoInv.uc
// Action Movie Arsenal for Postal 2

class amAutoAmmoInv extends AirMailInv
	config(AirMail);

// i added this to ensure maximum configurability of the auto-ammo
// some servers might have their own weapons such as the Scotts M-gun and the super shotgun.
// I think they use the same ammo but i'm not sure.
// Besides some servers use that piece of shit WMD and napalm and would probably want to have those regenerate too.
struct AmmoStruct
{
	var config class<P2AmmoInv> AmmoClass; // class of ammo
	var config int SleepPerAmmo; // number of seconds per ammo recovery
	var config int AmmoInc; // ammo recovery
	var P2AmmoInv OurAmmo; // pointer to our player's ammo of this type
	var int NumSleep; // how many times we've slept since we last replenished this ammo
};

// The AmmoArray makes it easy for us to add whatever number of ammo we want to the player's ammo classes
// without having to iterate through their inventory each time.
var config array<AmmoStruct> AmmoArray;
var sound OurPickupSound;
var P2Emitter OurEmitter;

// This ensures that our owner has all the ammo classes that we're gonna mess with
// Also spawns the ammo emitter
function GrantPowers(MpPawn Other)
{
	local Inventory inv;
	local int i;

	inv = Other.inventory;
	while (inv != None)
	{
		for (i=0;i<AmmoArray.Length;i++)
			if (inv.class == AmmoArray[i].AmmoClass)
				AmmoArray[i].OurAmmo = P2AmmoInv(inv);
		inv = inv.Inventory;
	}

	for (i=0;i<AmmoArray.Length;i++)
		if (AmmoArray[i].OurAmmo == None)
			AmmoArray[i].OurAmmo=P2AmmoInv(Other.CreateInventoryByClass(AmmoArray[i].AmmoClass));

	OurEmitter=spawn(class'amAmmoEmitter',Other,,Other.Location);
	OurEmitter.SetBase(Other);
}

function RevokePowers(MpPawn Other)
{
	OurEmitter.Destroy();
}

event Timer()
{
	local int i;
	local bool bAddedAmmo;

	bAddedAmmo=false;

	for (i=0;i<AmmoArray.Length;i++)
	{
		AmmoArray[i].NumSleep++;
		if (AmmoArray[i].NumSleep >= AmmoArray[i].SleepPerAmmo)
		{
			bAddedAmmo=true;
			AmmoArray[i].NumSleep = 0;
			AmmoArray[i].OurAmmo.AddAmmo(AmmoArray[i].AmmoInc);
		}
	}

	// this got too loud and annoying
	/*if (bAddedAmmo)
		OurOwner.PlaySound(OurPickupSound,,0.5);*/
}

defaultproperties
{
	PickupClass=class'amAutoAmmoPickup'
	OurPickupSound=Sound'WeaponSounds.weapon_picked_up'
	Icon=Texture'nathans.Inventory.AmmoInv'
	SLEEP_TIME = 0.5
	AmmoArray[0]=(AmmoClass=class'PistolBulletAmmoInv',SleepPerAmmo=1,AmmoInc=1)
	AmmoArray[1]=(AmmoClass=class'ShotGunBulletAmmoInv',SleepPerAmmo=3,AmmoInc=1)
	AmmoArray[2]=(AmmoClass=class'MachineGunBulletAmmoInv',SleepPerAmmo=2,AmmoInc=1)
	AmmoArray[3]=(AmmoClass=class'GrenadeAmmoInv',SleepPerAmmo=8,AmmoInc=1)
	AmmoArray[4]=(AmmoClass=class'MolotovAmmoInv',SleepPerAmmo=8,AmmoInc=1)
	AmmoArray[5]=(AmmoClass=class'ScissorsAmmoInv',SleepPerAmmo=2,AmmoInc=1)
	AmmoArray[6]=(AmmoClass=class'CowHeadAmmoInv',SleepPerAmmo=16,AmmoInc=1)
	AmmoArray[7]=(AmmoClass=class'RifleAmmoInv',SleepPerAmmo=16,AmmoInc=1)
	AmmoArray[8]=(AmmoClass=class'LauncherAmmoInv',SleepPerAmmo=3,AmmoInc=1)
	Description="AUTO-AMMO: Automatically replenishes your ammo"
}
