// amAutoArmorInv.uc
// Auto-Armor replenishes your armor

class amAutoArmorInv extends AirMailInv
	config(AirMail);

var sound OurPickupSound;
var config int ArmorPerSleep;
var P2Emitter OurEmitter;

// spawn our emitter
function GrantPowers(MpPawn Other)
{
	OurEmitter=spawn(class'amAutoArmorEmitter',Other,,Other.Location);
	OurEmitter.SetBase(Other);
}

// destroy our emitter
function RevokePowers(MpPawn Other)
{
	OurEmitter.Destroy();
}

event Timer()
{
	local int i;
	local bool bAddedArmor;

	bAddedArmor=true;

	// the body armor never kicks in for some reason, but i decided not to mess with it
	i = OurOwner.Armor;
	if (i < 100)
		OurOwner.AddArmor(ArmorPerSleep, Texture(class'KevlarInv'.Default.Icon), class'KevlarInv');
	else if (i < 200)
		OurOwner.AddArmor(ArmorPerSleep, Texture(class'BodyArmorInv'.Default.Icon), class'BodyArmorInv');
	else
		bAddedArmor=false;

	// copied from auto-ammo, never used
	/*if (bAddedAmmo)
		OurOwner.PlaySound(OurPickupSound,,0.5);*/
}

defaultproperties
{
	PickupClass=class'amAutoArmorPickup'
	OurPickupSound=Sound'WeaponSounds.weapon_picked_up'
	Icon=Texture'HUDPack.Icon_Special_Vest'
	SLEEP_TIME = 0.5
	ArmorPerSleep = 1
	Description="AUTO-ARMOR: Automatically regenerates your armor"
}
