// amDoghouseInv
// Spawns dog helpers

class amDoghouseInv extends AirMailInv
	config(AirMail);

// This gives the player dog helpers to attack enemies.
// Damage from dog helpers count as if it was dealt directly by the owner.
// Dog pawn animations don't work correctly in multiplayer games.
// However the functionality of the dog still works.

// Doghouse
// Spawns a few canines.

var config int MAX_DOGS; // Used to be 3, but was overpowered. Can be changed later if desired, or may make it a localized var

var array<DogController> DogList; // This is our list of dog controllers

function GrantPowers(MpPawn Other)
{
	// When picked up, choose a number of dogs to spawn
	DogList.Length = Rand(MAX_DOGS) + 1;
}

function RevokePowers(MpPawn Other)
{
	local int LCV;

	LCV=0;
	// Kill off all our dogs when we throw this, too cheap otherwise
	while (LCV < DogList.Length)
	{
		LCV++;
		If (DogList[LCV-1] != None)
			DogList[LCV-1].MyPawn.ChunkUp(200);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Add a controller to our newly spawned cat
///////////////////////////////////////////////////////////////////////////////
function AddController(AnimalPawn newcat)
{
	if ( newcat.Controller == None
		&& newcat.Health > 0 )
	{
		if ( (newcat.ControllerClass != None))
			newcat.Controller = spawn(newcat.ControllerClass);
		if ( newcat.Controller != None )
			newcat.Controller.Possess(newcat);
		// Check for AI Script
		newcat.CheckForAIScript();
	}
}

///////////////////////////////////////////////////////////////////////////////
// Active state: this inventory item is armed and ready to rock!
///////////////////////////////////////////////////////////////////////////////
function Activate()
{
	local MpPawn CheckPawn;
	local class<amDogPawn> aclass;
	local amDogPawn DogP;
	local amDogController DogC;
	local int LCV;

	CheckPawn = MpPawn(Owner);
	if (CheckPawn != None)
	{
		LCV=0;
		// When this is activated, we look to see if we have all the dog friends we're supposed to.
		// If not, spawn new ones.
		while (LCV < DogList.Length)
		{
			LCV++;
			If (DogList[LCV - 1] == None)
			{
				aclass = class<amDogPawn>(DynamicLoadObject("AirMail.amDogPawn", class'Class'));
				DogP=spawn(aclass,CheckPawn,,CheckPawn.Location,CheckPawn.Rotation);
				// FIXME: need to add random skin selection for dogs
				AddController(DogP);
				DogC=amDogController(DogP.Controller);			
				DogC.HookHero(CheckPawn); // the player is our hero
				DogC.ChangeHeroLove(DogC.HERO_LOVE_MAX,0);
				DogC.GoToHero();
				DogList[LCV - 1] = DogC;
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amDoghousePickup'
	Icon=Texture'AMTextures.Icons.doghouse'
	Description="DOGHOUSE: Activate this to get a few fellow canines to attack your enemies."
	Max_Dogs = 3
}
