// amGravTrap
// The actual gravity well trap.

class amGravTrap extends Actor
	config(AirMail);

var config float SUCK_DIST;
var config float SUCK_FORCE;

var sound SpawnSound;

// a little randomness for the sound
function float GetRandPitch()
{
	return (0.96 + FRand()*0.08);
}

// if something touches the center, it gets destroyed
function Touch(Actor Other)
{
	if (Other != Owner)
	{
		Other.TakeDamage(9999, Pawn(Owner), Location, Other.Velocity, class'amGravDamage');
		If (P2Pawn(Other) != None && Pawn(Other).Health <= 0)
			P2Pawn(Other).ChunkUp(9999);
	}
	Super.Touch(Other);
}

// Apply a force to anything within a radius of SUCK_DIST
function Tick(float DeltaTime)
{
	local actor Suckee;
	local vector SuckLoc;
	local vector HitNormal;
	local float Dist;
	local vector VelAdd;

	// RadiusActors is faster than DynamicActors here
	foreach RadiusActors(class'Actor', Suckee, SUCK_DIST)
	{
		//log ("Checking" @ Suckee);
		if (Suckee != Owner && Suckee != Self && (
		// Only suck in things affected by certain physics types
		//if (Suckee != Self && (
			Suckee.Physics == PHYS_Falling || // falling players, pickups and what have you
			Suckee.Physics == PHYS_Flying || // flying players with Icarus Wings
			Suckee.Physics == PHYS_Karma || // anything affected by karma
			Suckee.Physics == PHYS_KarmaRagdoll || // anything affected by karma
			Suckee.Physics == PHYS_Projectile || // projectiles such as nades and rockets
			Suckee.Physics == PHYS_Walking)) // walking players
		{
			HitNormal = Normal(Location - Suckee.Location);
			Dist = VSize(Location - Suckee.Location);
			If (Dist <= SUCK_DIST)
			{
				VelAdd = HitNormal * SUCK_FORCE * (SUCK_DIST - Dist);
				Suckee.Velocity += VelAdd;
				//log("Suckee" @ Suckee @ "Physics:" @ Suckee.Physics @ "HitNormal:" @ HitNormal @ "Distance:" @ Dist @ "VelAdd:" @ VelAdd @ "New Velocity:" @ Suckee.Velocity);
			}
		}
	}
	Super.Tick(DeltaTime);
}

function Destroyed()
{
	spawn(class'PawnExplosion',,,Location);
}

function PostBeginPlay()
{
	PlaySound(SpawnSound,SLOT_Misc,,,,GetRandPitch());
	Super.PostBeginPlay();
}

defaultproperties
{
	DrawType=DT_Sprite
	DrawScale=0.25
	Texture=Texture'AMTextures.Traps.GravTrap'
	bCollideActors=True
	SpawnSound=Sound'arcade.arcade_147'
	SUCK_DIST=1000
	SUCK_FORCE=0.15
}