// amHyperspaceInv
// Randomly teleports players across the map

class amHyperspaceInv extends AirMailInv
	config(AirMail);

// Teleporter
// Activate to teleport to coordinates of last use.

var int NumTeleports;
var float CurrentFailureRate;
var config float BASE_FAILURE_RATE;
var config float TELEPORT_FAILURE_INC;

var array<vector> TeleSpots;

// Have the guy teleport to a random pickup on the map.
// With any luck it will be a pickup the guy needs such as medkit or crack.
function FillTeleSpots()
{
	local Pickup foo;
	foreach DynamicActors(class'Pickup', foo)
	{
		if (!foo.IsA('AirMailPickup'))
			Telespots.Insert(TeleSpots.Length, 1.0);
			TeleSpots[TeleSpots.Length-1] = foo.Location;
	}
}

// set up for failure and fill the teleporter locations
function GrantPowers(MpPawn Other)
{
	CurrentFailureRate = BASE_FAILURE_RATE;
	FillTeleSpots();
}

// We tried to copy failure rate into the pickup but it didn't work?
///////////////////////////////////////////////////////////////////////////////
// Toss this item out.
///////////////////////////////////////////////////////////////////////////////
function DropFrom(vector StartLocation)
{
	local Pickup P;

	P = spawn(PickupClass,Instigator,,StartLocation);
	// if it's not spawned, try spawning it at the instigator
	if(P == None)
	{
		P = spawn(PickupClass,Instigator,,Instigator.Location);
	}

	if(P != None)
	{
		P.Instigator = Instigator;

		amHyperspacePickup(P).FailureRate = CurrentFailureRate;

		if(UseForErrands == 1
			&& Instigator != None
			&& P2Pawn(Instigator).Health > 0
			&& P2Player(Instigator.Controller) != None)
		{
			// Player says something about important item being dropped
			P2Player(Instigator.Controller).NeedThatForAnErrand();
		}

		// If throw each one and you have more than one, then only spawn a copy
		if(bThrowIndividually && Amount > 1)
		{
			// Throw out one
			if ( P == None )
			{
				return;
			}
			P.InitDroppedPickupFor(self);
			P.Velocity = Velocity;
			Velocity = vect(0,0,0);
		}
		else
		{
			///////////////////////////////////////////////////////////////////////////////
			// Similar to DropFrom in Inventory.uc, but we pass the instigator along to
			// the spawned pickup as its owner, because we want to know who most recently
			// dropped this for errands
			///////////////////////////////////////////////////////////////////////////////
			if ( Instigator != None )
			{
				DetachFromPawn(Instigator);	
				Instigator.DeleteInventory(self);
			}	
			SetDefaultDisplayProperties();
			Inventory = None;
			Instigator = None;
			StopAnimating();
			// moved spawn line from here to top of function
			if ( P == None )
			{
				return;
			}
			P.InitDroppedPickupFor(self);
			P.Velocity = Velocity;
			Velocity = vect(0,0,0);
			// End of inventory.uc code
			ReduceAmount(Amount);
		}
	}
	// If it still failed, ask the inventory what he wants to do
	else
	{
		DropFailed();
	}
}

// Randomly teleport when activated
function Activate()
{
	local vector Closet;
	local rotator CRotation;
	local PlayerReplicationInfo pri;

	pri = OurOwnerController.PlayerReplicationInfo;
	if (pri != None)
	{
		if (pri.HasFlag == None) // can't teleport with the babe
		{
			if (FRand()<CurrentFailureRate) // chance of failure
			{
				// instant death and gibbage
				OurOwner.TakeDamage(9999, OurOwner, OurOwner.Location, OurOwner.Location, class'amTeleporterDamage');
				if (OurOwner.Health <= 0)
					OurOwner.ChunkUp(9999);
			}
			else
			{
				// success, move them to the new location
				// any players who happen to be at the new location will be encroached upon (telefragged)
				Closet = OurOwner.Location;
				OurOwner.SetLocation(TeleSpots[Rand(TeleSpots.Length)]);
				spawn(class'amHyperspaceEffects',,,Closet);
				spawn(class'amHyperspaceEffects',,,OurOwner.Location);
				CurrentFailureRate+=TELEPORT_FAILURE_INC;
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amHyperspacePickup'
	Icon=Texture'P2Misc.Icons.S_Interestpoint'
	Description="PANIC BUTTON: Quickly teleport away from danger, but failure rate increases on each use"
	BASE_FAILURE_RATE=0.0
	TELEPORT_FAILURE_INC=0.15
}
