// amJihadGrenade
// A grenade that follows us wherever we go
// Serves as a visual indicator of our suicide bomber status

class amJihadGrenade extends Actor;

var vector ZVect;
var GrenadeTrail	GTrail;		// grenade smoke trail to make them easier to see

const SUCK_DIST=1000;
const SUCK_FORCE=0.25;

// Stub out exploding type things

// make a smoke trail like a regular grenade
function MakeSmokeTrail()
{
	if(GTrail == None)
	{
		if(Level.Game.bIsSinglePlayer)
		{
			// Send player as owner so it will keep up in slomo time
			GTrail = spawn(class'Fx.GrenadeTrail',Owner,,Location); 
			GTrail.SetBase(self);
		}
		else
			GTrail = spawn(class'Fx.GrenadeTrail',self,,Location); 
	}
}

// kill the trail
function KillSmokeTrail()
{
	if(GTrail != None)
	{
		GTrail.Destroy();
		GTrail = None;
	}
}

// Set up our random spinning
function SetupSpin()
{
	RotationRate.Roll=FRand()*3000;
	RotationRate.Pitch=FRand()*3000;
	RotationRate.Yaw=FRand()*3000;
	SetPhysics(PHYS_Projectile);
}

// Instead of "locking" our position to that of the player, simply change our velocity so that we follow the player around.
// Looks much smoother than updating our position every tick since ticks don't happen as often as we'd like in netplay
event Tick(float DeltaTime)
{
	local vector SuckLoc;
	local vector HitNormal;
	local float Dist;
	local vector VelAdd;

	if (GTrail == None)
		MakeSmokeTrail();

	Velocity = 3*(Owner.Location + zVect - Location);

	SetRotation(Rotation + RotationRate);
	Super.Tick(Deltatime);
}

// get rid of our smoke trail
function Destroyed()
{
	KillSmokeTrail();
	Super.Destroyed();
}

defaultproperties
{
	zVect=(Z=100)
	Drawtype=DT_StaticMesh
	StaticMesh=StaticMesh'stuff.stuff1.grenade'
	bRotateToDesired=false
}