// amOneRingInv
// Frodo imitation.

class amOneRingInv extends AirMailInv
	config(AirMail);

// The One Ring
// Invisibility when standing still and not firing.

var config int INVIZ_TIME; // Minimum time you must stand still with no weapon for invisibility to kick in
var config int VEL_TOLERANCE; // move any faster than this and we appear again

var float WaitToInviz; // Time in seconds before we can become invisible again.

function GrantPowers(MpPawn Other)
{
	WaitToInviz = 0.0;
}

function RevokePowers(MpPawn Other)
{
	If (Other.DrawType != DT_Mesh)
	{
		Other.SetDrawType(DT_Mesh);
		Other.Visibility = Other.Default.Visibility;
	}
}

// Here we check to see whether our pawn should be visible or invisible
function Timer()
{
	local MpPawn CheckPawn;
	local P2Player p2p;
	local bool bHasAWeapon;
	local bool bMoving;

	CheckPawn = OurOwner;
	p2p = P2Player(CheckPawn.Controller);
	If (CheckPawn != None && p2p != None)
	{
		bHasAWeapon = (HandsWeapon(P2Weapon(CheckPawn.Weapon)) == None);
		bMoving = (VSize(CheckPawn.Velocity) > Vel_Tolerance);
		// if we have no weapon out and we're standing still, then we can be invisible.
		// If we get jolted by an enemy attack our velocity won't be 0.0 so make them visible again
		if (!bHasAWeapon && !bMoving)
		{
			// Invisibility is performed by changing the pawn's DrawType to DT_None.
			// This gives the illusion of invisibility as the pawn is simply not drawn.
			WaitToInviz = WaitToInviz + SLEEP_TIME;
			If ((CheckPawn.DrawType != DT_None) && (WaitToInviz > INVIZ_TIME))
			{
				CheckPawn.SetDrawType(DT_None);
				CheckPawn.Visibility = 0;
			}
		}
		Else
		{
			WaitToInviz = 0;
			If (CheckPawn.DrawType != DT_Mesh)
			{
				CheckPawn.SetDrawType(DT_Mesh);
				CheckPawn.Visibility = CheckPawn.Default.Visibility;
			}
		}
	}

	Super.Timer();
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amOneRingPickup'
	Icon=Texture'AMTextures.Icons.OneRing'
	Description="THE ONE RING: Makes you invisible... but only when you stand still and don't have a weapon out. WARNING: Does not work against bots! (they're cheating bastards anyway)"
	AutoUseDesc="Hide your weapon and stand still, and within a few seconds you'll be invisible to humans!"
	Sleep_Time = 0.25
	Inviz_Time = 1
	Vel_Tolerance = 150
}
