// amRegenInv
// Regeneration

class amRegenInv extends amSuperHealthInv
	config(AirMail);

// Regeneration
// Sleeps and gradually restores the owner's health.
// When used, sets health to 100 and disappears.

// Extends from SuperHealthInv because of their similar behavior.

var config int HEALTH_PER_SLEEP; // in percent

var P2Emitter OurEmitter;

function GrantPowers(MpPawn Other)
{
	OurEmitter=spawn(class'amRegenEmitter',Other,,Other.Location);
	OurEmitter.SetBase(Other);
}

function RevokePowers(MpPawn Other)
{
	OurEmitter.Destroy();
}

simulated function float RateHealingPower()
{
	return 1;
	// We don't want to use this automatically because of its regenerative nature, so give it a rating of 1
}

// Auto-regenerate health when idle.
// Needs a sound effect... maybe steal the one from Quake
function Timer()
{
	local MpPawn CheckPawn;
	local int HealthToGain;

	CheckPawn = MpPawn(Owner);
	If (CheckPawn != None)
	{
		HealthToGain = int(CheckPawn.HealthMax * HEALTH_PER_SLEEP / 100);
		If (CheckPawn.Health < CheckPawn.HealthMax)
		{
			//log (Self @ "regenerating" @ HealthToGain @ "health to " @ CheckPawn);
			CheckPawn.Health += HealthToGain;
		}
		//else
			//log (Self @ "entered Regen() but" @ CheckPawn @ "is at max health.");				
	}

	Super.Timer();
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amRegenPickup'
	Icon=Texture'AMTextures.Icons.GreenHealth'
	USE_HEALTH_PCT=100 // Amount of health to recover
	Sleep_Time=0.5
	Health_Per_Sleep=1
	Description="REGENERATION: Gradually restores health. Activate to receive a health boost"
}
