// amSubspaceDistortion
// The actual subspace distortion trap.

class amSubspaceDistortion extends P2Projectile
	config(AirMail);

// This little bugger is mostly invisible
// Location given away by electric sparks.
// When any MpPawn touches it, the MpPawn is gibbed and a SubspaceExplosion occurs
// After a set time period the distortion will self-destruct if nobody's touched it yet.

const SLEEP_TIME = 2.5; // How often to spawn electric sparks
const WAIT_TO_ACTIVATE = 5.0; // Time limit before the distortion becomes "activated" to prevent our pawn from dying instantly
const HIT_MOMENTUM = 10; // hit momentum
var config int TIME_TO_SELF_DESTRUCT; // how long before the thing blows up

var bool bArmed;
var Sound SpawnSound;

simulated function ProcessTouch(Actor Other, Vector HitLocation)
{
	local MpPawn OtherPawn;

	OtherPawn=MpPawn(Other);
	// If we're armed and ready and someone touches us, kill them!
	If (OtherPawn != None && bArmed)
	{
		otherpawn.TakeDamage(DamageMP, MpPawn(Owner), HitLocation, HIT_MOMENTUM*VRand(), MyDamageType);
		if (OtherPawn.Health <= 0)
			OtherPawn.ChunkUp(255); // ensures the other pawn is gibbed
		spawn(class'amSubspaceExplosion', Owner); // and spawn an explosion to hurt nearby people as well
		Destroy();
	}
}

function Timer()
{
	// when our self-destruct timer runs out, spawn an explosion and disappear
	spawn(class'amSubspaceExplosion', Owner);
	Destroy();
}

auto state Sleeping
{
	function SetupDistortion()
	{
		// Plays a sound so others know what just happened here
		PlaySound(SpawnSound, SLOT_None,,,,GetRandPitch());
		bArmed = False;
		SetPhysics(PHYS_None); // prevents the engine from doing anything we don't want it to do to our distortion
	}
Begin:
	SetupDistortion();
	Sleep(WAIT_TO_ACTIVATE);
	bArmed = True;
	SetTimer(TIME_TO_SELF_DESTRUCT, False);
WaitLoop:
	spawn(class'ShockerPawnLightningMP'); // electric sparks
	Sleep(SLEEP_TIME);
	Goto('WaitLoop');
}

defaultproperties
{
	DamageMP=9999
	MyDamageType=class'amSubspaceDamage'
	SpawnSound=Sound'WeaponSounds.tazer_end'
	Time_To_Self_Destruct = 120
}
