// amSuperHealthInv
// Sets owner's health to 150

class amSuperHealthInv extends AirMailInv
	config(AirMail);

// Super Health
// When used, sets health to 150 and disappears.

var config int USE_HEALTH_PCT; // Amount of health to recover, in percent.

simulated function float RateHealingPower()
{
	return USE_HEALTH_PCT;
}

function bool OkayToUse()
{
	local MpPawn CheckPawn;
	// don't waste health if you're already at the max
	CheckPawn = MpPawn(Owner);
	if (CheckPawn.Health < int(CheckPawn.HealthMax * USE_HEALTH_PCT / 100))
		return true;
	else
		return false;
}

function UseIt()
{
	local MpPawn CheckPawn;
	// max out the player's health
	CheckPawn = MpPawn(Owner);
	CheckPawn.Health = int(CheckPawn.HealthMax * USE_HEALTH_PCT / 100);
	P2Player(CheckPawn.Controller).NotifyGotHealth(USE_HEALTH_PCT);
}

function CommentOnIt()
{
	local P2MocapPawn CheckPawn;

	CheckPawn = P2MocapPawn(Owner);
	if(P2Player(CheckPawn.Controller) != None)
	{
		P2Player(CheckPawn.Controller).EatingFood(); 
		P2Player(CheckPawn.Controller).CommentOnCrackUse();
	}
		// Spawn some bread crumbs so others know that we've used this
}

function Activate()
{
	if (OkayToUse())
	{
		UseIt();
		CommentOnIt();
		Destroy();
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amSuperHealthPickup'
	Icon=Texture'AMTextures.Icons.MedKit'
	USE_HEALTH_PCT=150
	Description="SUPER HEALTH: Activate to get 150% Health"
}
