// amTaikwanLeapInv
// Boot to the head

class amTaiKwanLeapInv extends amAirJordanInv;

// Get rid of the regular foot and give them a Boot To The Head weapon
function GrantMightyFoot(P2Pawn P2P)
{
	local Inventory thisinv;

	thisinv = P2P.CreateInventoryByClass(class'amBootToTheHead');
	if(FootWeapon(thisinv) != None)
	{
		// We don't destroy the old foot here, we just temporarily disable it
		P2P.MyFoot = P2Weapon(thisinv);
		P2P.MyFoot.GotoState('Idle');
		P2P.MyFoot.bJustMade=false;
		if(P2P.Controller != None)
			P2P.Controller.NotifyAddInventory(P2P.MyFoot);
		P2P.ClientSetFoot(P2Weapon(thisinv));
	}
}

function RestoreNormalFoot(P2Pawn P2P)
{
	local Inventory inv;
	local FootWeapon RegularFoot;
	local amBootToTheHead MightyFoot;

	// Find the old foot and link it back up
	inv = P2P.Inventory;
	while (inv != None)
	{
		if (inv.class==class'amBootToTheHead')
			MightyFoot = amBootToTheHead(inv);
		if (inv.class==class'FootWeapon')
			RegularFoot = FootWeapon(inv);
		inv = inv.inventory;
	}

	// delete the Mighty Foot if we still have it
	if (MightyFoot != None)
		P2P.DeleteInventory(MightyFoot);

	// if we lost our regular foot somehow, add it back
	if (RegularFoot == None)
	{
		RegularFoot = FootWeapon(P2P.CreateInventoryByClass(class'FootWeapon'));
		RegularFoot.bJustMade=false;
		if(P2P.Controller != None)
			P2P.Controller.NotifyAddInventory(RegularFoot);
	}

	// now put our regular foot back
	if (RegularFoot != None)
	{
		P2P.MyFoot = RegularFoot;
		P2P.MyFoot.GotoState('Idle');
		P2P.ClientSetFoot(RegularFoot);
	}
}

function GrantPowers(MpPawn Other)
{
	GrantMightyFoot(Other);
}

function RevokePowers(MpPawn Other)
{
	RestoreNormalFoot(Other);
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amTaiKwanLeapPickup'
	Icon=Texture'AMTextures.Icons.boot'
	Description="TAI KWAN LEAP: Give your enemies a boot to the head"
	AutoUseDesc="Just use your normal kick (default Q key) and give your enemies a boot to the head!"
	Jump_Mult = 110;
	Speed_Mult = 105;
}
