// amTeleporterInv
// Move back and forth between two teleporter locations

class amTeleporterInv extends AirMailInv
	config(AirMail);

// Teleporter
// Activate to teleport to coordinates of last use.

var vector LastUsedCoords;
var rotator LastUsedRotation;
var bool bWaitToUse;
var config float TeleWaitTime;

// DoFacing doesn't work on clients.
// It's supposed to remember what direction you were facing and restore that facing
// upon teleportation.

replication
{
	// stuff the server sends to the client
	reliable if (ROLE == ROLE_Authority)
		DoFacing;
	unreliable if (ROLE == Role_Authority)
		LastUsedRotation;
}

function PickupFunction(Pawn Other)
{
	// When picked up, set the pickup location as our first teleport destination.
	Super.PickupFunction(Other);
	LastUsedCoords = Other.Location;
	LastUsedRotation = Other.Rotation;
	bWaitToUse = false;
}

function Timer()
{
	// Prevents abuse, must wait one second before teleporting again.
	bWaitToUse = false;
}

simulated function DoFacing(P2Player p2p)
{
	p2p.SetRotation(LastUsedRotation);
}

function Activate()
{
	local MpPawn CheckPawn;
	local vector Closet;
	local rotator CRotation;
	local PlayerReplicationInfo pri;
	local P2Player p2p;
	local bool bTeleFailed;

	CheckPawn = MpPawn(Owner);
	pri = MpPlayer(CheckPawn.Controller).PlayerReplicationInfo;
	p2p = P2Player(CheckPawn.Controller);
	if (CheckPawn != None && !bWaitToUse && pri != None && p2p != None)
	{
		if (pri.HasFlag == None)
		{
			Closet = CheckPawn.Location;
			CRotation = CheckPawn.Rotation;
			CheckPawn.SetLocation(LastUsedCoords);
			// teleport our pawn to lastusedcoords
			// If some unlucky sap happens to be standing there they get TELEFRAGGED!
			DoFacing(p2p);
			//CheckPawn.SetRotation(LastUsedRotation);
			LastUsedCoords = Closet;
			LastUsedRotation = CRotation;
			spawn(class'amTeleporterEffects',,,Closet);
			spawn(class'amTeleporterEffects',,,OurOwner.Location);
			// cool exploding effect for teleport
			bWaitToUse = true;
			SetTimer(TeleWaitTime, false);
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	PickupClass=class'amTeleporterPickup'
	Icon=Texture'P2Misc.Icons.S_Telemarketer'
	Description="TELEPORTER: Use this to teleport to the last location you used it."
	TeleWaitTime=3.0	
}
