// amWeirdProjectile
// The actual projectile that induces weirdness effects.

class amWeirdProjectile extends P2Projectile
	config(AirMail);

var config array<string> WeirdEffects;

event Touch(actor Other)
{
	local MpPawn MpP;
	local P2Player P2P;
	local class<amWeirdness> NewWeird;
	local amWeirdness OurWeird;

	MpP=MpPawn(Other);
	if (MpP != None && MpP != MpPawn(Owner)) // direct hit!
	{
		// spawn a random weirdness
		NewWeird=class<amWeirdness>(DynamicLoadObject(WeirdEffects[Rand(WeirdEffects.Length)], class'Class'));
		OurWeird=spawn(NewWeird);
		// have it "infect" the pawn
		OurWeird.pwned(MpP);
		// and tell your owner
		PlayerController(Pawn(Owner).Controller).ClientMessage("Weirded out" @ MpP.PlayerReplicationInfo.PlayerName @ "with" @ OurWeird.OurWeirdEffect2);

		Destroy();
	}

	Super.Touch(Other);
}

simulated function HitWall (vector HitNormal, actor Wall)
{
	BounceRecoil(HitNormal);
}

event Timer()
{
	Destroy();
}

defaultproperties
{
	DrawType=DT_Sprite
	DrawScale=0.25
	Style=STY_Translucent
	Texture=Texture'AMTextures.Icons.BlueBub'

	WeirdEffects[0]="AirMail.amWVertigo"
	WeirdEffects[1]="AirMail.amWJumpy"
	WeirdEffects[2]="AirMail.amWCoffee"
	WeirdEffects[3]="AirMail.amWPoopy"
	WeirdEffects[4]="AirMail.amWBass"
	//WeirdEffects[0]="AirMail.amWoobe"
}